package de.intevation.flys.exports;

import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.IOException;

import org.w3c.dom.Document;

import org.apache.log4j.Logger;

import de.intevation.artifacts.Artifact;
import de.intevation.artifacts.CallContext;

import de.intevation.flys.artifacts.FLYSArtifact;

import de.intevation.artifactdatabase.state.Facet;

import de.intevation.flys.artifacts.model.WQ;

public class ATExporter
implements   OutGenerator
{
    private static Logger logger = Logger.getLogger(ATExporter.class);

    public static final String DEFAULT_ENCODING = "UTF-8";

    protected WQ           data;
    protected CallContext  context;
    protected OutputStream out;

    public ATExporter() {
    }

    @Override
    public void init(Document request, OutputStream out, CallContext context) {
        this.context = context;
        this.out     = out;
    }

    @Override
    public void setMasterArtifact(Artifact master) {
        // not needed
    }

    @Override
    public void doOut(Artifact artifact, Facet facet, Document attr) {

        FLYSArtifact flys = (FLYSArtifact)artifact;

        if ((facet = flys.getNativeFacet(facet)) == null) {
            logger.debug("native facet not found.");
            return;
        }

        data = (WQ)facet.getData(flys, context);
    }

    @Override
    public void generate() throws IOException {

        if (data == null) {
            logger.debug("no W/Q data");
            return;
        }

        ATWriter at;
        try {
            at = new ATWriter(data);
        }
        catch (IllegalArgumentException iae) {
            logger.error("creating ATWriter failed", iae);
            throw new IOException(iae);
        }

        at.write(new OutputStreamWriter(out, DEFAULT_ENCODING));
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
